#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################

#############################################################################


from Products.Archetypes.public import BaseFolderSchema, Schema
from Products.Archetypes.public import BaseFolder, registerType

from Products.CMFFolder.config import *

from Products.Archetypes.public import BooleanField, FixedPointField, IntegerField, LinesField, StringField, TextField
from Products.Archetypes.public import BooleanWidget, DecimalWidget, IntegerWidget, LinesWidget, SelectionWidget, StringWidget, TextAreaWidget


from Products.CMFCore import CMFCorePermissions
from AccessControl import ClassSecurityInfo

from Products.CMFCore.utils import getToolByName
#from Persistence import Persistent

#from Products.PageTemplates.PageTemplateFile import PageTemplateFile
from AccessControl import getSecurityManager, SpecialUsers
from Acquisition import aq_base, aq_parent, Acquired, Implicit

from Permissions import *
import string


#############################################################################
##                             Setting                                     ##
#############################################################################

schema = BaseFolderSchema +  Schema((
    StringField('title',
                searchable=1,
                required=1,
                ),
    #ImageField('foldericon',
    #            mutator='setFoldericon',
    #            widget=ImageWidget(
    #              label="icon",
    #              ),
    #          ),
    BooleanField('within_cmffolder',
              default='1',
              mode='r',
              ),
    LinesField('left_slots',
              mode='r',
              accessor='left_slots'
              ),
    LinesField('custom_left_slots',
              widget=LinesWidget(
                  label="left slots",
                  description="leave blank if you want to acquire setting; type 'empty' if you do not use any slot.",
                  ),
              ),
    LinesField('right_slots',
              mode='r',
              accessor='right_slots'
              ),
    LinesField('custom_right_slots',
              widget=LinesWidget(
                  label="right slots",
                  description="leave blank if you want to acquire setting; type 'empty' if you do not use any slot.",
                  ),
              ),
    BooleanField ('selectable_style',
              default=None,
              widget=BooleanWidget(label="Selectable style",
                  description="Check this only if you want to allow all users " + \
                              "use the style of this folder"
                 ),
        ),
    TextField('css_fields',
              default='',
              widget=TextAreaWidget(label="Cascading Style Sheet",
                         description='Input your css code for this folder here'),
              ),
    IntegerField('max_quota_bytes',
              default='0',
              write_permission=SetQuota,
              mutator='setMax_quota_bytes',
              widget=IntegerWidget(
                  label="Quota Size in Bytes",
                  description="(0 for no limit)",
                  ),
              ),
    IntegerField('max_quota_objects',
              default='0',
              write_permission=SetQuota,
              mutator='setMax_quota_objects',
              widget=IntegerWidget(
                  label="Maximum number of Objects",
                  description="(0 for unlimited)",
                  ),
              ),
    IntegerField('max_object_size',
              default='0',
              write_permission=SetQuota,
              mutator='setMax_object_size',
              widget=IntegerWidget(
                  label="Maximum Object Size in Bytes",
                  description="(0 for unlimited)",
                  ),
              ),
    LinesField('quota_categories',
              default=['Basic:all'],
              write_permission=SetQuota,
              mutator='setQuota_categories',
              widget=LinesWidget(label="Quota Categories",
                         description='You can cateogrize the quota counting, quota will be counted for each category' \
                                     'e.g. "Creators:mary,john" will only check Mary\'s and John\'s objects respectively. '\
                                     'Now, only "Creators" category is available. Default is "Basic:all" which did not filter any object.'),
              ),
    BooleanField ('apply_sub_folderish',
              write_permission=SetQuota,
              default='0',
              mutator='setApply_sub_folderish',
              widget=BooleanWidget(label="Apply Quota To All subfolders(non-CMFFolder)",
                  description="Apply the quota setting to all folderish contents inside"
                 ),
        ),
    BooleanField ('is_allow_nested',
              write_permission=SetQuota,
              default='1',
              mutator='setIs_allow_nested',
              widget=BooleanWidget(label="Allow Nested",
                  description="Allow creating CMFFolder insider another CMFFolder"
                 ),
        ),
    ))


#class CMFFolder(BaseFolder, Persistent, Implicit):
class CMFFolder(BaseFolder):
    """
        CMFFolder has quota count and assistant tools
    """
    security = ClassSecurityInfo()
    
    schema = schema
    archetype_name = "CMF Folder"
    
    #allow_discussion = 1
    
    global_allow = 1
    
    
    
    filter_content_types = 0
    security = ClassSecurityInfo()

    
    actions = (
          { 'id': 'folderContents'
               ,'name': 'Contents'
               ,'action': 'string: ${folder_url}/folder_contents'
               ,'condition': 'python:member and folder is not object and object.displayContentsTab()'
               ,'permissions': (CMFCorePermissions.ListFolderContents,)
               , 'category'      : 'object'
               , 'visible'       : 1
          },
          {'id': 'view',
                'name': 'View',
                'action': 'string:folder_listing',
                'permissions': (CMFCorePermissions.View,),
                'category'      : 'object',
                'visible'       : 1 },
          { 'id'            : 'local_roles'
              , 'name'          : 'Sharing'
              , 'action'        : 'string:${folder_url}/folder_localrole_form'
              , 'permissions'   :
                 (CMFCorePermissions.ManageProperties,)
              , 'category'      : 'folder'
              , 'visible'       : 1
          },
          { 'id': 'folderlisting'
               ,'name': 'Folder Listing'
               ,'action': 'string:${folder_url}/folder_listing'
               ,'permissions': (CMFCorePermissions.View,)
               , 'category'      : 'folder'
               , 'visible'       : 0
          },
          { 'id': 'content_status_history'
               ,'name': 'State'
               ,'action': 'string:$object_url/content_status_history'
               ,'condition': 'python:object and portal.portal_workflow.getTransitionsFor(object, object.getParentNode())'
               ,'permissions': (CMFCorePermissions.View,)
               , 'category'      : 'object_tabs'
               , 'visible'       : 0
          })


    security.declareProtected(CMFCorePermissions.View, 'getIcon')
    def getIcon(self, relative_to_portal=0):
        return 'cmffolder_icon.gif'
        

    security.declareProtected( CMFCorePermissions.View, 'left_slots' )        
    def left_slots(self):
        val = self.getCustom_left_slots()
        if not val:
            parent = self.aq_parent
            if hasattr(parent, 'left_slots'):
                ls = parent.left_slots
                if callable(ls):
                    return ls()
                else:
                    return ls
            else:
                return []
        elif 'empty' in val:
            return []
        else:
            return val
    
    security.declareProtected( CMFCorePermissions.View, 'right_slots' )        
    def right_slots(self):
        val = self.getCustom_right_slots()
        if not val:
            parent = self.aq_parent
            if hasattr(parent, 'right_slots'):
                rt = parent.right_slots
                if callable(rt):
                    return rt()
                else:
                    return rt
            else:
                return []
        elif 'empty' in val:
            return []
        else:
            return val
 
 
    ##### Mutators #####
    
    security.declareProtected( SetQuota, 'setMax_quota_bytes' ) 
    def setMax_quota_bytes(self, value, **kwargs):
        tool = self.cmffolder_tool
        if not kwargs.has_key('force'):
            if value and (str(value) <> str(tool.MAX_QUOTA_BYTES)):
                if tool.DISABLE_FOLDERISH_SETTING:
                    raise CMFFolderSetQuotaException, \
                              "Folder's setting violate the cmffolder_tool setting. You are not permitted to change the quota setting."
            
        schema = self.Schema()
        field = schema.get('max_quota_bytes', 0)
        field.set(instance=self, value=value)
    
    security.declareProtected( SetQuota, 'setMax_quota_objects')
    def setMax_quota_objects(self, value, **kwargs):
        
        tool = self.cmffolder_tool
        # check if cmffolder_tool disable folderish setting
        if not kwargs.has_key('force'):
            if value and (str(value) <> str(tool.MAX_QUOTA_OBJECTS)):
                if tool.DISABLE_FOLDERISH_SETTING:
                    raise CMFFolderSetQuotaException, \
                              "Folder's setting violate the cmffolder_tool setting. You are not permitted to change the quota setting."
        schema = self.Schema()
        field = schema.get('max_quota_objects', 0)
        field.set(instance=self, value=value)

    security.declareProtected( SetQuota, 'setMax_object_size' )        
    def setMax_object_size(self, value, **kwargs):
        # check if cmffolder_tool disable folderish setting
        tool = self.cmffolder_tool
        if not kwargs.has_key('force'):
            if value and (str(value) <> str(tool.MAX_OBJECT_SIZE)):
                if tool.DISABLE_FOLDERISH_SETTING:
                    raise CMFFolderSetQuotaException, \
                              "Folder's setting violate the cmffolder_tool setting. You are not permitted to change the quota setting."
        schema = self.Schema()
        field = schema.get('max_object_size', 0)
        field.set(instance=self, value=value)
    
    
    security.declareProtected( SetQuota, 'setIs_allow_nested' )        
    def setIs_allow_nested(self, value, **kwargs):
        # check if cmffolder_tool disable folderish setting
        tool = self.cmffolder_tool
        if not kwargs.has_key('force'):
            if value and (str(value) <> str(tool.IS_ALLOW_NESTED)):
                if tool.DISABLE_FOLDERISH_SETTING:
                    raise CMFFolderSetQuotaException, \
                              "Folder's setting violate the cmffolder_tool setting. You are not permitted to change the quota setting."
        
        # check logically possible
        if value not in [1,'1']:
            if self.check_nested():
                 raise CMFFolderNestedException, \
                      "You has nested CMFFolder within this folder, please remove it first before setting the folder to non-nestable."

        schema = self.Schema()
        field = schema.get('is_allow_nested', None)
        field.set(instance=self, value=value)
    
    
    
    security.declareProtected( SetQuota, 'setQuota_categories' )        
    def setQuota_categories(self, value, **kwargs):
        # check if cmffolder_tool disable folderish setting
        tool = self.cmffolder_tool
        if not kwargs.has_key('force'):
            if value and (str(value) <> str(tool.QUOTA_CATEGORIES)):
                if tool.DISABLE_FOLDERISH_SETTING:
                    raise CMFFolderSetQuotaException, \
                              "Folder's setting violate the cmffolder_tool setting. You are not permitted to change the quota setting."
        
        
        schema = self.Schema()
        field = schema.get('quota_categories', None)
        field.set(instance=self, value=value)
    
    security.declareProtected( SetQuota, 'setApply_sub_folderish' )        
    def setApply_sub_folderish(self, value, **kwargs):
        # check if cmffolder_tool disable folderish setting
        tool = self.cmffolder_tool
        if not kwargs.has_key('force'):
            if value and (str(value) <> str(tool.APPLY_SUB_FOLDERISH)):
                if tool.DISABLE_FOLDERISH_SETTING:
                    raise CMFFolderSetQuotaException, \
                              "Folder's setting violate the cmffolder_tool setting. You are not permitted to change the quota setting."
        
        
        schema = self.Schema()
        field = schema.get('apply_sub_folderish', None)
        field.set(instance=self, value=value)
        
    ### Checking functions ####
    security.declarePublic('check_nested')
    def check_nested(self):
        path=self.absolute_url('relative')
        path=path.replace('%20', ' ')
        items= self.portal_catalog(meta_type='CMFFolder', path=path)
        if len(items)>1:   #self is included
            return 1
        else:
            return 0
            
            
    def manage_afterAdd(self, item, container):
        # print "afterAdd %s %s"%(str(item), str(container))
        parent = self.aq_parent
        while hasattr(parent, 'aq_parent'):
            if hasattr(parent.aq_explicit, 'getIs_allow_nested'):
                allow_nested= parent.aq_explicit.getIs_allow_nested()
                if not allow_nested:
                    raise CMFFolderNestedException, \
                      "Cannot add a CMFFolder inside this non-nestable CMFFolder"
            parent = parent.aq_parent
            
        # maybe we can check_over_size and check_over_count here
        
        BaseFolder.manage_afterAdd(self, item, container)
          


registerType(CMFFolder)
